"""
本作品采用知识共享署名-非商业性使用-相同方式共享 4.0 国际许可协议进行许可。
当您使用本作品相关图纸或源码等资料时，视为您同意并遵循此协议内容。

项目开源地址：https://www.laserblock.cn/thread-23573-1-1.html

作者：李嘉泳
邮箱：17620745509@126.COM
BiliBili：https://space.bilibili.com/106497171

Laserblock开源社区：https://www.laserblock.cn/
"""
print("IMPORTING STEPPER")
# mPythonType:0
from mpython import *
import config as cfg


class stepper_struct:
    def __init__(self):
        self.step_pwm_count = cfg.cfg["core"]["stepper"]["step_pwm"]
        self.delay = cfg.cfg["core"]["stepper"]["delay"]
        self.current_step = 1


stepper = stepper_struct()

p13 = MPythonPin(13, PinMode.OUT)
p14 = MPythonPin(14, PinMode.OUT)
p15 = MPythonPin(15, PinMode.OUT)
p16 = MPythonPin(16, PinMode.OUT)


def set_pin_state(a, b, c, d):
    if a:
        p13.write_digital(1)
    else:
        p13.write_digital(0)
    if b:
        p14.write_digital(1)
    else:
        p14.write_digital(0)
    if c:
        p15.write_digital(1)
    else:
        p15.write_digital(0)
    if d:
        p16.write_digital(1)
    else:
        p16.write_digital(0)
    time.sleep_ms(stepper.delay)


def set_step_gpio():
    if stepper.current_step == 1:
        set_pin_state(True, False, False, False)
    if stepper.current_step == 2:
        set_pin_state(True, True, False, False)
    if stepper.current_step == 3:
        set_pin_state(False, True, False, False)
    if stepper.current_step == 4:
        set_pin_state(False, True, True, False)
    if stepper.current_step == 5:
        set_pin_state(False, False, True, False)
    if stepper.current_step == 6:
        set_pin_state(False, False, True, True)
    if stepper.current_step == 7:
        set_pin_state(False, False, False, True)
    if stepper.current_step == 8:
        set_pin_state(True, False, False, True)


def step():
    global stepper
    stepper.current_step += 1
    if stepper.current_step == 9:
        stepper.current_step = 1
    set_step_gpio()


def invert_step():
    global stepper
    stepper.current_step -= 1
    if stepper.current_step == 0:
        stepper.current_step = 8
    set_step_gpio()


def steps(steps=stepper.step_pwm_count):
    if steps > 0:
        for count in range(int(steps)):
            step()
    if steps < 0:
        steps = steps * -1
        for count in range(int(steps)):
            invert_step()
    stop()


def stop():
    set_pin_state(False, False, False, False)
